<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml" indent="yes"/>
    <xsl:template match="/testResults">
        <xsl:element name="testsuite">
            <xsl:attribute name="name">
                <xsl:text>jmeter</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="tests">
                <xsl:value-of select="count(distinct-values((//httpSample/assertionResult | //sample/assertionResult)/concat(../@lb, name)))"/>
            </xsl:attribute>
            <xsl:attribute name="errors">
                <xsl:value-of select="count(//httpSample/assertionResult[error='true'] | //sample/assertionResult[error='true'])"/>
            </xsl:attribute>
            <xsl:attribute name="failures">
                <xsl:value-of select="count(//httpSample/assertionResult[failure='true'] | //sample/assertionResult[failure='true'])"/>
            </xsl:attribute>
            <xsl:for-each-group select="httpSample/assertionResult | sample/assertionResult" group-by="concat(../@lb, name)">
                <xsl:element name="testcase">
                    <xsl:attribute name="classname">
                        <xsl:value-of select="../@lb"/>
                    </xsl:attribute>
                    <xsl:attribute name="name">
                        <xsl:value-of select="name"/>
                    </xsl:attribute>
                    <xsl:attribute name="time">
                        <xsl:value-of select="avg(current-group()/../@t)"/>
                    </xsl:attribute>
                    <xsl:for-each select="current-group()">
                        <xsl:choose>
                            <xsl:when test="failure='true'">
                                <xsl:element name="failure">
                                    <xsl:attribute name="type">
                                        <xsl:value-of select="name"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="message">
                                        <xsl:value-of select="failureMessage"/>
                                    </xsl:attribute>
                                </xsl:element>
                            </xsl:when>
                            <xsl:when test="error='true'">
                                <xsl:element name="error">
                                    <xsl:attribute name="type">
                                        <xsl:value-of select="name"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="message">
                                        <xsl:value-of select="errorMessage"/>
                                    </xsl:attribute>
                                </xsl:element>
                            </xsl:when>
                        </xsl:choose>
                    </xsl:for-each>
                </xsl:element>
            </xsl:for-each-group>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>
